-- Lua itemhud recreation.
-- Adapted by Snu from TSR, by Snu. xd

local function isDisplayPlayer(p)
	for dp, n in displayplayers.iterate
		if (p != dp) then continue end	-- that's not us
		return n
	end
	
	-- if we're here, we're not a displayplayer
	return false
end

local function returnSplitflags(f, displaynum)
	if not (splitscreen) return f end

	-- exhibit 1: 2p
	if (splitscreen == 1)
		if not (displaynum) -- p1
			return f & ~(V_SNAPTOBOTTOM)
		else	-- p2
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP)
		end
	else
		-- jesus fuck this sucks dicks
		if not (displaynum)	-- p1
			return f & ~(V_SNAPTOBOTTOM|V_SNAPTORIGHT)
		elseif (displaynum == 1)	-- p2
			return (f|V_HORZSCREEN) & ~(V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif (displaynum == 2)	-- p3
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP|V_SNAPTORIGHT)
		elseif (displaynum == 3)	-- p4
			return (f|V_SPLITSCREEN|V_HORZSCREEN) & ~(V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
	
	return f	-- shouldn't happen but don't return nil either way lol
end

hud.add(function(v, p, c)
	if leveltime == 0 then 
		hud.enable("item")
	end
	if G_BattleGametype() then return end
	if not JUICEBOX.value then return end
	if not (p.mo and p.mo.valid and p.gatedecay) then return end
	local right = (isDisplayPlayer(p) == 1 or isDisplayPlayer(p) == 3)
	local x, y = 5, (splitscreen) and 3 or 5
	local flags = returnSplitflags(V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, isDisplayPlayer(p))
	if ((splitscreen) > 1)
		x, y = (right) and 121 or -9, -8
		flags = returnSplitflags(V_SNAPTOLEFT|V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS, isDisplayPlayer(p))
	end
	local split_prefix = (splitscreen > 1) and "S" or "T"

-- unseal when fuckery is required
--local tx = 320 - 148
--local ty = 9
--local timeflags = returnSplitflags(V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS, isDisplayPlayer(p))	
--v.draw(tx, ty, v.cachePatch("J_STTIMW"), timeflags, v.getColormap(TC_BLINK, SKINCOLOR_PINK))

local gatebarsplit = (splitscreen > 1) and "S" or "R"
if splitscreen == 1 then gatebarsplit = "M" end
local gatebar = v.cachePatch("GBA"..gatebarsplit..((leveltime/3)%4)..(100-p.gatedecay))
local itblink = p.kartstuff[k_itemblink]>4 and (not p.JBflashhold) and leveltime%2 -- JUICE: we hold itemblink for hyu balance but it looks shitty
local showgatebar = (p.gatedecay < 100 or p.gatebarhappy < (1*TICRATE/3+6) or p.kartstuff[k_itemtype])
	
	-- draw the background
	local drawn = false
	local function drawItemBackground(v, ghost)
		if (drawn) then return end
		-- ^ make sure it's not drawn multiple times
		
if ghost then
	v.draw(x, y, v.cachePatch("K_I"..split_prefix.."BG"), flags&(~V_HUDTRANS)|V_HUDTRANSHALF)
else

			v.draw(x, y, v.cachePatch("K_I"..split_prefix.."BG"), flags)
			
end

		drawn = true

	end
	
if showgatebar

local tcol = v.getColormap(p.mo.skin, p.mo.color)
if p.gatedecay == 100 and (leveltime % 2) then
	tcol = v.getColormap(TC_ALLWHITE, SKINCOLOR_WHITE)
elseif p.techedrecently and (leveltime % 2) then
	tcol = v.getColormap(TC_BLINK, p.skincolor)
elseif p.kartstuff[k_position] == 1 then
	tcol = v.getColormap(TC_RAINBOW, SKINCOLOR_BLACK)
end
local tflag = flags&(~V_HUDTRANS)|((p.kartstuff[k_position] == 1) and V_HUDTRANSHALF or V_HUDTRANS)
if splitscreen>1 then
if right then
	v.drawScaled((x+13)<<FRACBITS, (y+34)<<FRACBITS, FRACUNIT, gatebar, V_FLIP|tflag, tcol)
else
	v.drawScaled((x+35)<<FRACBITS, (y+34)<<FRACBITS, FRACUNIT, gatebar, tflag, tcol)
end
else
v.drawScaled((x+46)<<FRACBITS, (y+46)<<FRACBITS, FRACUNIT, gatebar, tflag, tcol)
end


end
	
	local itemPatchs = {"K_ITSHOE", "K_ITBANA", "K_ITORB1", "K_ITMINE", "K_ITGROW", "K_ITHYUD", "K_ITRSHE", "K_ITJAWZ", "K_ITSPB", "K_ITSHRK", "K_ITINV"..leveltime%21/3+1, "K_ITEGGM", "K_ITBHOG", "K_ITTHNS"}
	if ((splitscreen) > 1)
		itemPatchs = {"K_ISSHOE", "K_ISBANA", "K_ISORBN", "K_ISMINE", "K_ISGROW", "K_ISHYUD", "K_ISRSHE", "K_ISJAWZ", "K_ISSPB", "K_ISSHRK", "K_ISINV"..leveltime%18/3+1, "K_ISEGGM", "K_ISBHOG", "K_ISTHNS"}
	end

	-- the item roulette
	if (p.kartstuff[k_itemroulette])
		drawItemBackground(v)
		
		local itemPatch = itemPatchs[p.kartstuff[k_itemroulette]%42/3+1]
		v.draw(x, y, v.cachePatch(itemPatch), flags, v.getColormap(TC_RAINBOW, p.skincolor))
	end

	if (p.kartstuff[k_itemtype] and not p.kartstuff[k_itemroulette])
		drawItemBackground(v)
		
		local numberPatches = {"K_ITSHOE", "K_ITRSHE", "K_ITINV"..leveltime%21/3+1, "K_ITBANA", "K_ITEGGM", "K_ITORB"..max(1, min(4, p.kartstuff[k_itemamount])), "K_ITJAWZ", "K_ITMINE", "K_ITBHOG", "K_ITSPB", "K_ITGROW", "K_ITSHRK", "K_ITTHNS", "K_ITHYUD", "K_ITPOGO", "K_ITSINK"}
		if ((splitscreen) > 1)
			numberPatches = {"K_ISSHOE", "K_ISRSHE", "K_ISINV"..leveltime%18/3+1, "K_ISBANA", "K_ISEGGM", "K_ISORBN", "K_ISJAWZ", "K_ISMINE", "K_ISBHOG", "K_ISSPB", "K_ISGROW", "K_ISSHRK", "K_ISTHNS", "K_ISHYUD", "K_ISPOGO", "K_ISSINK"}
		end

		-- multiple item overlay
		if (p.kartstuff[k_itemamount] > 1 and not (not (splitscreen > 1) and (p.kartstuff[k_itemtype] == KITEM_ORBINAUT and p.kartstuff[k_itemamount] < 5)))
			local pp = v.cachePatch("K_I"..split_prefix.."MUL")
			
			local flipflag, flipshift = 0, 0
			if ((splitscreen > 1) and right)
				flipflag, flipshift = V_FLIP, (pp.width)-1
			end
			
			v.draw(x+flipshift, y, pp, flipflag|flags)
		end
		
		-- the item
		if not (p.kartstuff[k_itemheld] and leveltime%2)
		and not (p.kartstuff[k_stealingtimer] > 0 and leveltime%3)
			local itemPatch = numberPatches[p.kartstuff[k_itemtype]] or "K_ITSAD"
			local colourmapSkin = (itblink) and -6 or -1
			local blinkColours = {SKINCOLOR_RED, leveltime%SKINCOLOR_LILAC+1}
			
			v.draw(x, y, v.cachePatch(itemPatch), flags, v.getColormap(colourmapSkin, (itblink) and (blinkColours[p.kartstuff[k_itemblinkmode]] or SKINCOLOR_WHITE) or SKINCOLOR_NONE))
		end
		
		-- how much of said item
		if (p.kartstuff[k_itemamount] > 1)
			if not (not (splitscreen > 1) and (p.kartstuff[k_itemtype] == KITEM_ORBINAUT and p.kartstuff[k_itemamount] < 5))
				if ((splitscreen) > 1)
					local hx = (right) and x+2 or x+24
					v.drawString(hx, y+31, "x"..p.kartstuff[k_itemamount], flags|V_ALLOWLOWERCASE)
				else
					v.draw(x+28 - (splitscreen and 2 or 0), y+41, v.cachePatch("K_ITX"), flags)	-- for some reason this is shifted by 2 pixels in splitscreen???
					v.drawKartString(x+38, y+36, p.kartstuff[k_itemamount], flags)
				end
			end
		end
	end

	-- flashing icons and timer bars (some timers appear when they're > 0 and others when they're > 1)
	local timerChecks = {
		{{k_stealingtimer, "HYUD", 3}, {k_stolentimer, "HYUD", 3}, {k_sadtimer, "SAD", 3}, {k_growshrinktimer, "GROW", 2, {k_growcancel, 26}}}, -- > 0 timer bars
		{{k_eggmanexplode, "EGGM", 2}, {k_rocketsneakertimer, "RSHE", 2, {k_rocketsneakertimer, 814}}} -- > 1 timer bars
	}

	for tbl = 1, 2
		for i = 1, #timerChecks[tbl]
			local timer = timerChecks[tbl][i]
			-- flashing icons
			if (p.kartstuff[timer[1]] > (tbl-1))
				drawItemBackground(v)
				
				if (leveltime%timer[3])
					v.draw(x, y, v.cachePatch("K_I"..(splitscreen > 1 and "S" or "T")..timerChecks[tbl][i][2]), flags)
				end
			end
			
			-- timer bars
			if (timer[4] and p.kartstuff[timer[4][1]] > 0)
				local coords = (splitscreen > 1) and {x+17, y+27} or {x+11, y+35}

				-- main bar
				v.draw(coords[1], coords[2], v.cachePatch((splitscreen > 1) and "K_ISIMER" or "K_ITIMER"), flags)

				-- borders
				local length = (splitscreen > 1) and 12 or 26
					
				v.drawFill(coords[1]+1, coords[2]+1, p.kartstuff[timer[4][1]]*length/timer[4][2], 1, 120|flags)
				if not (splitscreen > 1) then v.drawFill(coords[1]+1, coords[2]+2, p.kartstuff[timer[4][1]]*length/timer[4][2], 1, 8|flags) end
				v.drawFill(coords[1]+1, coords[2]+1, 1, (splitscreen > 1 and 1 or 2), 12|flags)
				if (p.kartstuff[timer[4][1]]*length/timer[4][2] > 0) then v.drawFill(coords[1]+p.kartstuff[timer[4][1]]*length/timer[4][2], coords[2]+1, 1, (splitscreen > 1 and 1 or 2), 12|flags) end
			end
		end
	end

	-- draw the eggbox numbers
	if (p.kartstuff[k_eggmanexplode] > 1) and (p.kartstuff[k_eggmanexplode] <= 4*TICRATE-1) -- eggpanic
		drawItemBackground(v)
		local second = min(3, G_TicsToSeconds(p.kartstuff[k_eggmanexplode]))
		v.draw(x+(splitscreen > 1 and 16 or 17), y+(splitscreen > 1 and 11 or 13), v.cachePatch("K_EGGN"..second), flags)
	end
	
if showgatebar

drawItemBackground(v, true)

end
	
	-- disable the base item box
	hud.disable("item")
end)