-- base code by Wolfs, concept by Wolfs+Barkley

freeslot("sfx_tekyes")
freeslot("sfx_tekprf")

-- [TYRON] was TICRATE/2 (17)
local techwindow = TICRATE/3
-- [TYRON] was 23
local lockout = 2*TICRATE/3

local function realtechwindow(p)
	return (techwindow + (9 - min(p.kartweight, JUICEBOX_weightadjust)))
end

local jb_techringpre = {value = 7}

-- haste shit
local bonusfactor = 3*FRACUNIT/10

local function TechBoost(player, consolation)

	local diefactor = FRACUNIT + FixedMul(FixedDiv(bonusfactor, FRACUNIT*8), (9-min(player.kartspeed, JUICEBOX_weightadjust))*FRACUNIT)
	local holding = FixedInt(FixedMul(20*FRACUNIT, diefactor))
	
	player.kartstuff[k_driftboost] = 26

	if (player.kartstuff[k_spinouttimer]) then
		if abs(player.kartstuff[k_spinouttimer] - realtechwindow(player)) <= 1 then -- perfect!
			JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s25f, player)
			if CV_FindVar("kartvoices").value then
				local techsound = (leveltime%2) and sfxinfo[sfx_kbost1] or sfxinfo[sfx_kbost2]
				JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(skins[player.mo.skin].soundsid[techsound.skinsound], player)
			end
			player.techsparkle = TICRATE
		end
		player.kartstuff[k_spinouttimer] = 0
	end
	
	if consolation then
		JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s23c, player)
		player.kartstuff[k_driftboost] = $ - 5
	else
		JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_tekyes, player)
		player.techedrecently = TICRATE/4 -- [TYRON] controls length of sparkle trail post-tech
	end
	
	player.JBQRok = false
	player.JBhascontrol = 999
	player.techcue = false
	player.techcuering = false
end

freeslot("MT_TECHFLASH")
freeslot("S_TECHFLASH1")
freeslot("S_TECHFLASH2")
freeslot("S_TECHFLASH3")
freeslot("S_TECHFLASH4")
freeslot("S_TECHFLASHXD")
freeslot("SPR_TKFL")
freeslot("SPR_TKLT")
mobjinfo[MT_TECHFLASH] = {
	spawnstate = S_TECHFLASHXD,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP|MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY,
	dispoffset = 10, -- BE CAREFUL WITH THIS FUCKING PARAMETER, too high and you'll run into broken camera culling behavior in OGL at low cam_dist
	height = 48*FRACUNIT -- (and make sure you set this too, if you don't specify it Lua sets it to 0 and you get weird software culling)
}
states[S_TECHFLASHXD] = {
	sprite = SPR_NULL,
	frame = A|FF_FULLBRIGHT,
	tics = 1,
	nextstate = S_TECHFLASH1
}
states[S_TECHFLASH1] = { -- intro
	sprite = SPR_TKFL,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 15,
	var2 = 1,
	tics = 15,
	nextstate = S_TECHFLASH2
}
states[S_TECHFLASH2] = { -- "TECH OK" ring loop
	sprite = SPR_TKFL,
	frame = Q|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 3,
	var2 = 1,
	nextstate = S_TECHFLASH2
}
states[S_TECHFLASH3] = { -- expand, fade out to QR visual
	sprite = SPR_TKFL,
	frame = U|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 4,
	var2 = 1,
	tics = 5,
	nextstate = S_TECHFLASH4
}
states[S_TECHFLASH4] = { -- "QR OK" ring loop
	sprite = SPR_TKLT,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 7,
	var2 = 1,
	tics = 8,
	nextstate = S_TECHFLASH4
}
addHook("MobjSpawn", function(mo)
	mo.animtimer = 0
end, MT_TECHFLASH)
addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.target and mo.target.valid) then return end
	mo.animtimer = $ + 1
	
	if mo.target.player.tech then
		P_RemoveMobj(mo)
	else
		if mo.target.player.kartstuff[k_spinouttimer] <= (mo.target.player.cmd.latency) and (mo.state != S_TECHFLASH3 and mo.state != S_TECHFLASH4) then
			mo.state = S_TECHFLASH3
		end
	end
end, MT_TECHFLASH)

freeslot("MT_TECHBUTTON")
freeslot("S_TECHBUTTON")
freeslot("S_TECHBUTTONB")
freeslot("S_TECHBUTTONXD")
freeslot("SPR_TKBT")
mobjinfo[MT_TECHBUTTON] = {
	spawnstate = S_TECHBUTTONXD,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP|MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY,
	dispoffset = 11,
	height = 48*FRACUNIT
}
states[S_TECHBUTTONXD] = {
	sprite = SPR_NULL,
	frame = A|FF_FULLBRIGHT,
	tics = 1,
	nextstate = S_TECHBUTTON
}
states[S_TECHBUTTON] = {
	sprite = SPR_TKBT,
	frame = A|FF_FULLBRIGHT
}
states[S_TECHBUTTONB] = {
	sprite = SPR_TKBT,
	frame = C|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 1,
	var2 = 1,
	tics = 6,
	nextstate = S_NULL
}
addHook("MobjSpawn", function(mo)
	mo.animtimer = 0
end, MT_TECHBUTTON)
addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.target and mo.target.valid) then return end
	mo.animtimer = $ + 1
	if (mo.target.player != JUICEBOX_dp and (not splitscreen)) then mo.flags2 = $|MF2_DONTDRAW else mo.flags2 = $&(~MF2_DONTDRAW) end
	if mo.animtimer == 2 then
		mo.frame = B|FF_FULLBRIGHT
	elseif mo.animtimer == 8 then
		mo.frame = C|FF_FULLBRIGHT
	end
	if mo.target.player.tech then
		P_RemoveMobj(mo)
	else
		if mo.target.player.kartstuff[k_spinouttimer] <= (6 + mo.target.player.cmd.latency) and (mo.state != S_TECHBUTTONB) then
			--mo.markedfordeath = $ or 0
			--mo.markedfordeath = $ + 1
			--if mo.target.player == JUICEBOX_dp then
				--mo.flags2 = (mo.markedfordeath % 2) and ($|MF2_DONTDRAW) or ($&~(MF2_DONTDRAW))
			--end
			--if mo.markedfordeath == 8 then
				--P_RemoveMobj(mo)
			--end
			mo.state = S_TECHBUTTONB
		end	
	end
end, MT_TECHBUTTON)

freeslot("MT_TECHLOCK")
freeslot("S_TECHLOCK")
freeslot("S_TECHLOCKXD")
mobjinfo[MT_TECHLOCK] = {
	spawnstate = S_TECHLOCKXD,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP|MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY,
	dispoffset = 12,
	height = 48*FRACUNIT
}
states[S_TECHLOCKXD] = {
	sprite = SPR_NULL,
	frame = A|FF_FULLBRIGHT,
	tics = 1,
	nextstate = S_TECHLOCK
}
states[S_TECHLOCK] = {
	sprite = SPR_TKBT,
	frame = E|FF_FULLBRIGHT
}
addHook("MobjSpawn", function(mo)

end, MT_TECHLOCK)
addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.target and mo.target.valid) then return end
	if (mo.target.player != JUICEBOX_dp and (not splitscreen)) then mo.flags2 = $|MF2_DONTDRAW else mo.flags2 = $&(~MF2_DONTDRAW) end
	if mo.target.player then
		if mo.target.player.lockout then
			mo.frame = E|FF_FULLBRIGHT
			if mo.target.player.lockout == lockout then
				mo.scale = 12*(mo.target.scale)/10
				mo.destscale = mo.target.scale
			end
		else
			P_RemoveMobj(mo)
		end
	else
		P_RemoveMobj(mo)
	end
end, MT_TECHLOCK)

local killme = {MT_TECHBUTTON, MT_TECHFLASH, MT_TECHLOCK}
for i = 1, #killme
	addHook("MobjThinker", function(mo)
		if not (mo and mo.valid) then return end
		if leveltime == 1 then -- I AM TIRED OF THIS HAPPENING
			P_RemoveMobj(mo)
			return
		end
		if mo.target and mo.target.valid and mo.target.player
		and mo.target.player.playerstate == PST_LIVE then
			P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
			mo.angle = mo.target.angle
			--mo.momx, mo.momy, mo.momz = mo.target.momx, mo.target.momy, mo.target.momz
			if (mo.target.player.lockout or (not P_IsObjectOnGround(mo.target))) and mo.type != MT_TECHLOCK then
				--mo.flags2 = $|MF2_SHADOW
			else
				--mo.flags2 = $&(~MF2_SHADOW)
			end
		else
			P_RemoveMobj(mo)
			return
		end
		-- achtung big hack, need to remove tech visuals if your spinout is somehow extended
		local player = mo.target.player
		local techwindowadj = realtechwindow(player)
		if mo.type == MT_TECHBUTTON then
			if player.techcue and (player.kartstuff[k_spinouttimer] > (techwindowadj + player.cmd.latency + 1)) then
				--print("removing button out of range")
				P_RemoveMobj(mo)
				player.techcue = false
				player.lockout = 0
				return
			end
		elseif mo.type == MT_TECHFLASH then
			if player.techcuering and (player.kartstuff[k_spinouttimer] > (techwindowadj + player.cmd.latency + jb_techringpre.value + 1)) then
				--print("removing ring out of range")
				P_RemoveMobj(mo)
				player.techcuering = false
				player.lockout = 0
				return
			elseif (mo.state == S_TECHFLASH4 or mo.state == S_TECHFLASH3) and (not JUICEBOX_CanQuickRecover(player))
				--print("removing ring no QR")
				player.techcuering = false
				P_RemoveMobj(mo)
				return
			end
		end
	end, killme[i])
end


addHook("ThinkFrame", do
	if not JUICEBOX.value then return end
	for player in players.iterate do
		
		if not (player.mo) or not (player.mo.valid) then
			continue -- go fuck yourself
		end
		
		if leveltime == 1 then -- experimental patch for techvisual fucking off?
			player.techcue = false
			player.techcuering = false
			player.JBQRok = false
		end
	
		-- Declare initial variables and handle resets
		if (player.tech == nil) 
		or ((player.kartstuff[k_spinouttimer] == 0) and (player.kartstuff[k_driftboost] == 0)) then
			player.tech = 0
			player.lockout = 0
			player.accelcounter = $ or 0
			player.brakecounter = $ or 0
		end

		player.techedrecently = $ or 0 -- [TYRON] little accent for techboosts
		player.techedrecently = max($-1, 0)
		if player.techedrecently then
			K_SpawnSparkleTrail(player.mo)
		end
		
		player.techsparkle = $ or 0 -- fuck it
		player.techsparkle = max($-1, 0)
		if player.techsparkle and (not player.techedrecently) and (leveltime%2) then
			K_SpawnSparkleTrail(player.mo)
		end

		if (player.lockout > 0) then
			player.lockout = $-1 -- Count down the lockout every frame
		end
		
		-- Count held accelerate inputs, used for lockout
		if (player.cmd.buttons & BT_ACCELERATE) then
			player.accelcounter = $+1
		else
			player.accelcounter = 0
		end
		
		-- [TYRON] fuck it
		if (player.cmd.buttons & BT_BRAKE) then
			player.brakecounter = $+1
			-- player.accelcounter = 0 -- Allows for instant techs when BRAKE is released.
			-- Not implementing this just yet: seems to require too much finesse when releasing after RBT.
		else
			player.brakecounter = 0
		end
		
		if (player.kartstuff[k_spinouttimer]) and (not player.mo.ggz_frozen) then
			-- [TYRON] More lenient techs for lighter fucks
			local techwindowadj = realtechwindow(player)
			table.insert(JUICEBOX_dwatch, "RTW: "..techwindowadj)

			if (true) then
				-- [TYRON] latency-adjusted tech window visual cue
				if not player.techcue and (player.kartstuff[k_spinouttimer] <= (techwindowadj + player.cmd.latency + 1)) then
					local shitty = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TECHBUTTON)
					shitty.target = player.mo
					--shitty.momx, shitty.momy, shitty.momz = player.mo.momx, player.mo.momy, player.mo.momz
					player.techcue = true
					JUICEBOX_StartLocalSound(sfx_ddash, player)
				end
				
				if not player.techcuering and (player.kartstuff[k_spinouttimer] <= (techwindowadj + player.cmd.latency + jb_techringpre.value + 1)) then
					local notshitty = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TECHFLASH)
					notshitty.target = player.mo
					--notshitty.momx, notshitty.momy, notshitty.momz = player.mo.momx, player.mo.momy, player.mo.momz
					notshitty.colorized = true
					notshitty.color = player.skincolor
					JUICEBOX_StartLocalSound(sfx_s227, player)
					player.techcuering = true
				end
			end

			-- SUCCESS TIMING WINDOW: Any accelerate inputs within this window will result in a tech.
			if (player.tech == 0) 
			and (player.kartstuff[k_spinouttimer] <= (techwindowadj)) -- [TYRON] Moved lag compensation to the visual
			-- this isn't like startboosts, where everyone's action is determined at the same time;
			-- we want laggy players to press earlier so their input arrives on time. a later spinout cancel is competitively worse!
			and (player.lockout == 0) then
				if (player.accelcounter == 1) and (player.brakecounter == 0) then
					if 	P_IsObjectOnGround(player.mo) then
						TechBoost(player)
					else
						player.airtech = true
						player.JBhascontrol = 999
					end
					player.tech = 1
				end
			end

			-- LOCKOUT: If the player presses accelerate before the timing window begins, lock their input from counting towards techs.
			if (player.accelcounter == 1) and (player.brakecounter < player.accelcounter)
			and ((player.kartstuff[k_spinouttimer]) > (techwindowadj)) then
				player.lockout = lockout
				JUICEBOX_StartLocalSound(sfx_s268, player)
				local shame = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TECHLOCK)
				shame.target = player.mo
			end
		else
			player.techcue = false -- [TYRON] unset this out here dummy
			if not JUICEBOX_CanQuickRecover(player)
				player.techcuering = false
			end
		end
		
		if P_IsObjectOnGround(player.mo) and player.airtech then
			TechBoost(player)
			player.airtech = false
		end
		
	end
end)
